﻿'''Bien que cela ne soit pas nécessaire, les bibliothèques
sont appelées en début de chaque script afin de pourvoir facilement
les dissocier'''


from random import randint
de = randint(1,6)
c = 1
while de != 6 :
    de = randint(1,6)
    c = c + 1


from random import randint
def lancer(n):
    res = [ randint(1,6) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    c = 1
    while n != 0:
        res = [de for de in res if de != 6]
        n = len(res)
        res = [ randint(1,6) for i in range(n)]
        c = c + 1
    return c


from random import randint
def lancer_demi(n):
    res = [ randint(1,6) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    c = 1
    N = n
    while n >= N/2:
        res = [de for de in res if de != 6]
        n = len(res)
        res = [ randint(1,6) for i in range(n)]
        c = c + 1
    return c


from random import randint
import matplotlib.pyplot as plt
def lancer_graphe(n):
    res = [ randint(1,6) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    ord = [n]
    c = 1
    while n != 0:
        res = [de for de in res if de != 6]
        n = len(res)
        res = [ randint(1,6) for i in range(n)]
        ord.append(n)
        c = c + 1
    plt.plot(ord,color='red',linestyle='none',marker = '+')
    plt.show()
    return c


## autre méthode possible : utiliser plt.scatter() (Utiliser dans le chapitre suites)
from random import randint
import matplotlib.pyplot as plt
def lancer_graphe(n):
    res = [ randint(1,6) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    ord = [n]
    c = 1
    while n != 0:
        res = [de for de in res if de != 6]
        n = len(res)
        res = [ randint(1,6) for i in range(n)]
        ord.append(n)
        c = c + 1
    abs=[i for i in range(c)]
    plt.scatter(abs,ord,color='red',marker = '+')
    plt.show()
    return c

from random import randint
import matplotlib.pyplot as plt
def lancer_graphe(n):
    res = [ randint(1,6) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    ord = [n]
    c = 1
    while n != 0:
        res = [de for de in res if de != 6]
        n = len(res)
        res = [ randint(1,6) for i in range(n)]
        ord.append(n)
        c = c + 1
    plt.plot(ord,color='red',linestyle='none',marker = '+')
    plt.yscale('log')
    plt.grid(True,which="both", linestyle='--')
    plt.xlabel('Nombre de lancers') # non nécessaire ds le modèle élève
    plt.ylabel('nombre de dés')
    plt.show()
    return c

## avec vérification graphique de la droite d'ajustement déterminée en utilisant la copie d'écran du TP
from random import randint
from math import exp    #à ajouter
import matplotlib.pyplot as plt
def lancer_graphe(n):
    N = n #garder la valeur initiale de n
    res = [ randint(1,6) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    ord = [n]
    c = 1
    while n != 0:
        res = [de for de in res if de != 6]
        n = len(res)
        res = [ randint(1,6) for i in range(n)]
        ord.append(n)
        c = c + 1
    plt.plot(ord,color='red',linestyle='none',marker = '+')
    plt.yscale('log') # à enlever si vérification avec les points dans un repère linéaire
    plt.grid(True,which="both", linestyle='--')
    plt.xlabel('Nombre de lancers') # non nécessaire ds le modèle élève
    plt.ylabel('nombre de dés')
    #instructions pour tracer graphe solution
    c_abs=[i for i in range(c)]
    c_ord=[N*exp(-0.185*i) for i in c_abs]
    plt.plot(c_abs,c_ord,color='b')
    # fin insctruction pour tracer graphe solution
    plt.show()
    return c




from random import uniform
def désintégration(n,p):
    res = [ uniform(0,1) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    c = 1
    while n != 0:
        res = [de for de in res if de>p]
        n = len(res)
        res = [ uniform(0,1) for i in range(n)]
        c = c + 1
    return c

from random import uniform
def désintégration_demi(n,p):
    res = [ uniform(0,1) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    c = 1
    N = n
    while n >= N/2: # à remplacer par N/4 puis 0,1*N
        res = [de for de in res if de>p]
        n = len(res)
        res = [ uniform(0,1) for i in range(n)]
        c = c + 1
    return c

import matplotlib.pyplot as plt
from random import uniform
def désintégration_graphe(n,p):
    res = [ uniform(0,1) for i in range(n)] # permet de créer une liste correspondant au lancer simultané de n dés
    c = 1
    ord = [n]
    while n != 0:
        res = [de for de in res if de>p]
        n = len(res)
        res = [ uniform(0,1) for i in range(n)]
        ord.append(n)
        c = c + 1
    plt.plot(ord,color='red',linestyle='none',marker = '.',markersize=1)
    plt.yscale('log')
    plt.grid(True,which="both", linestyle='--')
    plt.xlabel('dizaines de jours') # non nécessaire ds le modèle élève
    plt.ylabel('nombre de noyaux')
    plt.show()
    return c
